var game;
var titre;
var pause = true;
var player1;
var player2;
var cursors;
var WKey;
var AKey;
var SKey;
var DKey;
var AKey;
var ZKey;
var spaceKey;
var enterKey;
var pad1;
var pad2;
var tabPersos=[];
var fleche;
var overLapTab=[];
var focusInsp;
var zIndexPersos;
var groupMenu;
var music;
var dumbIA= false;
var temps = 120;
var timer;
var timerSprites = [];
var win;

var player1Velocity = 160;
var persoVelocity = 150;
var nbPersos = 10;
var maxPersos = 14;


window.onload = function() {
    game = new Phaser.Game(1000, 300, Phaser.CANVAS, 'godGame', { preload: preload, create: create, update: update, render: render },false,false);
    var divGame = document.getElementById("godGame");
    divGame.style.position = "absolute";
    divGame.style.left = "50%";
    divGame.style.top = "50%";
    divGame.style.margin = "-150px 0 0 -500px";
};

function preload() {
    game.load.spritesheet('titre', 'data/titre.png',1000,300);
    game.load.spritesheet('insp', 'data/insp.png', 34, 56);
    game.load.spritesheet('persos', 'data/persos.png', 42, 80);
    game.load.image('fond', 'data/fond.png', 42, 80);
    game.load.spritesheet('fleche', 'data/fleche.png', 41, 49);
    game.load.spritesheet('chiffres', 'data/chiffres.png', 12, 12);
    game.load.audio('music', ['data/ld30.mp3', 'data/ld30.ogg']);
    game.load.spritesheet('win', 'data/win.png', 206, 25);
}



function create() {
    //game.scale.fullScreenScaleMode = Phaser.ScaleManager.EXACT_FIT;
    //game.scale.pageAlignHorizontally = true;
    //game.scale.pageAlignVeritcally = true;
    //game.scale.refresh();

    game.physics.startSystem(Phaser.Physics.ARCADE);
    game.stage.backgroundColor = '#2b2b2b';
    game.add.image(0,0,'fond');


    

    

    //  Our controls.
    cursors = game.input.keyboard.createCursorKeys();
    WKey = game.input.keyboard.addKey(Phaser.Keyboard.W);
    AKey = game.input.keyboard.addKey(Phaser.Keyboard.A);
    SKey = game.input.keyboard.addKey(Phaser.Keyboard.S);
    DKey = game.input.keyboard.addKey(Phaser.Keyboard.D);
    QKey = game.input.keyboard.addKey(Phaser.Keyboard.Q);
    ZKey = game.input.keyboard.addKey(Phaser.Keyboard.Z);
    spaceKey = game.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);
    enterKey = game.input.keyboard.addKey(Phaser.Keyboard.ENTER);
    
    // To listen to buttons from a specific pad listen directly on that pad game.input.gamepad.padX, where X = pad 1-4
    pad1 = game.input.gamepad.pad1;
    pad2 = game.input.gamepad.pad2;
    game.input.gamepad.start();
    

    

    

    music = game.add.audio('music',1,true);
    music.play();

    titre = game.add.sprite(0,0,'titre');
    titre.inputEnabled = true;
    titre.events.onInputUp.add(validTitre, this);    

    timer = game.time.create(false);
    timer.loop(Phaser.Timer.SECOND, updateTimer, this);

}

function update() {
    if(!pause) {
        var left, right, up, down, LT, btX, btA, left2, right2, btA2 = false;
        if(pad1._rawPad) {
            if (pad1._rawPad.axes[1] >0.1) right = true;
            else if (pad1._rawPad.axes[1]< -0.1) left=true;

            if (pad1._rawPad.axes[0] <-0.1) up=true;
            else if (pad1._rawPad.axes[0] >0.1) down = true;

            if (pad1._rawPad.buttons[0].value) btA=true;
            if (pad1._rawPad.axes[4]>0.1) LT = true;

        }

        if(pad2._rawPad) {
            if (pad2._rawPad.axes[1] >0.2) right2 = true;
            else if (pad2._rawPad.axes[1]< -0.2) left2=true;

            if (pad2._rawPad.buttons[0].value) btA2=true;
        }

        if (!game.estFini) testCollision();
        else if (enterKey.isDown || btA || btA2) restart();

       

        player1.body.velocity.x = 0;
        
        
        // player1 control
        if (player1.animations.currentAnim.name !='accuse' && !game.estFini){
            tabPersos.forEach(function(e){e.body.velocity.x=0; animPerso(e);})
            if (AKey.isDown || QKey.isDown || left)
            {
                player1.body.velocity.x = -player1Velocity;
                if (player1.scale.x > 0) player1.scale.x *= -1;
                player1.animations.play('marche');
            }
            else if (DKey.isDown || right)
            {
                player1.body.velocity.x = player1Velocity;
                if (player1.scale.x < 0) player1.scale.x *= -1;
                player1.animations.play('marche');
            } else {
                player1.animations.play('nomove');
            }

            // player2 control
            if (!dumbIA) {
                if (cursors.left.isDown || left2)
                {
                    moveLeft(player2);
                }
                else if (cursors.right.isDown || right2)
                {
                    moveRight(player2);
                } else {
                    stopPerso(player2);
                }

                if (cursors.up.isDown || btA2)
                {
                    console.log("provocation");
                } 
            }

            // question
            if (WKey.isDown || ZKey.isDown || btA)
            {
                if (focusInsp) {
                    player1.animations.play('accuse',null,false);
                    tabPersos.forEach(function(e) {stopPerso(e); });
                }
            } else if (spaceKey.isDown || LT) {
                if (focusInsp) {
                    player1.animations.play('accuse', null, true);
                    checkEnd();
            }
            }
        } else if (!game.estFini) {
            fleche.rotation += 0.2;
            if (cursors.left.isDown || left2)
            {
                player2.orientLeft = true;
            }
            else if (cursors.right.isDown || right2)
            {
                player2.orientLeft = false;
            }
        }


    }    

       // if (cursors.up.isDown || up) {*/

}

function render () {
    //game.debug.body(player1);
    //tabPersos.forEach(function(e){game.debug.body(e)});
}


function addPersos () {
    tabPersos=[];
    zIndexPersos = game.add.group();

    for (var i=0;i<nbPersos;i++) {
        var perso = game.add.sprite(Math.floor(Math.random()*1000),110, 'persos');
        perso.animations.add('nomove', [0+i*9], 3, false);
        perso.animations.add('perdu', [1+i*9], 3, false);
        perso.animations.add('gagne', [2+i*9], 3, false);
        perso.animations.add('marche', [3+i*9,4+i*9,5+i*9,6+i*9,7+i*9,8+i*9], 6, true);
        perso.animations.play('marche')
        perso.scale.set(2.5,2.5);
        perso.anchor.setTo(.5, .5);


     
        game.physics.arcade.enable(perso);
        perso.body.collideWorldBounds = true;
        perso.body.setSize(16, 80,0,0);
        tabPersos.push(perso);
        zIndexPersos.add(perso);
    }

    player2 = tabPersos[Math.floor(Math.random()*nbPersos)];
    // selectionner player2
}

function moveLeft(perso) {
    if (perso.body.x < 1) {
        stopPerso(perso);
        perso.mouvement = 'right';
        perso.body.x =0;
    } else {
        perso.body.velocity.x = -persoVelocity;
        if (perso.scale.x > 0) perso.scale.x *= -1;
        perso.animations.play('marche');
    }
}

function moveRight (perso) {
    if (perso.body.x > game.world.width-perso.body.width-1) {
        stopPerso(perso);
        perso.mouvement = 'left';
        perso.body.x = game.world.width-perso.body.width;
    } else {
        perso.body.velocity.x = persoVelocity;
        if (perso.scale.x < 0) perso.scale.x *= -1;
        perso.animations.play('marche');
    }
}

function stopPerso(perso) {
    perso.animations.play('nomove');
    perso.body.velocity.x =0;
}

function animPerso(perso) {
    if (perso!=player2 || (perso==player2 && dumbIA)) {
        if (perso.nbPas>0) {
            if (perso.mouvement == 'left') {
                moveLeft(perso);
            } else if (perso.mouvement== 'right') {
                moveRight(perso);
            } else {
                stopPerso(perso);
            }
            perso.nbPas--;
        } else {
            dirPerso(perso);
            animPerso(perso);
        }
    }
}

function dirPerso (perso) {
    var chanceLeft = 0.4;
    var chanceRight = 0.4;
    var minPas = 20;
    var maxPas = 300;
    var choix = Math.random();

    chanceRight += chanceLeft;
    maxPas-= minPas;

    if (choix<chanceLeft) {
        perso.mouvement = 'left';
    } else if (choix<chanceRight) {
        perso.mouvement = 'right';
    } else {
        perso.mouvement = 'stop';
    }


    perso.nbPas = minPas + Math.floor (Math.random()*maxPas);
}

function testCollision() {
    if (fleche.countdown > 0) {
        fleche.countdown--;
        if (fleche.countdown ==0) {
            fleche.rotation =0;
            fleche.alpha =0;
        }
    } else {
        overLapTab = [];
        var alreadyFocus = false;

        for (var i=tabPersos.length-1;i>-1;i--) {

            var perso = tabPersos[i];
            if ( game.physics.arcade.overlap(player1, perso) ) {
                if (perso == focusInsp) alreadyFocus = true;
                overLapTab.push (perso);
            }
        }

        if (overLapTab.length == 0) {
            fleche.alpha = 0;
            focusInsp = null;
        } else {
            if (!alreadyFocus) {
                focusInsp = overLapTab[0];
            }
            fleche.alpha = 1;
            fleche.x = focusInsp.body.x + 18;

        }
    }
}

function finAccuse (e) {
    var orientLeft = true;
    player1.animations.play('nomove');
    fleche.countdown = 80;
    if (focusInsp == player2) {
        if (dumbIA) {
            orientLeft = lyingIA();
        } else {
            if (!player2.orientLeft) orientLeft = false;
        }
    } else if (!testOrientLeft()) orientLeft = false;


    if (orientLeft) {
        fleche.rotation = Math.PI*0.5;
    } else {
        fleche.rotation = Math.PI*1.5;
    }
    focusInsp = null;
}

function testOrientLeft () {
    if (player2.body.x<focusInsp.body.x) return true;
    else return false;
}

function fullScreen () {
    if (game.scale.isFullScreen)
    {
        game.scale.stopFullScreen();
    }
    else
    {
        game.scale.startFullScreen();
    }
}

function restart () {
    

    fleche.alpha = 0;
    timer = game.time.create(true);
    timer.temps = temps;
    affTimer();

    win.alpha = 0;

    tabPersos.forEach(function(e){e.alpha = 0;e.body.x = Math.floor(Math.random()*800);e.alpha = 1;});
    player2 = tabPersos[Math.floor(Math.random()*tabPersos.length)];
    player2.orientLeft = true;


    // reset player 1
    player1.body.x = 400;
    player1.animations.play('nomove');
    overLapTab=[];
    focusInsp = null;
    timer.loop(1000, updateTimer, this);
    game.time.events.add(Phaser.Timer.SECOND/10, function() {
        game.estFini= false;
        timer.start();
        } , this);
}

function validTitre () {
    titre.animations.frame++;
    if (titre.animations.frame == 2) {
        titre.events.onInputUp.remove(validTitre, this);  
        game.input.onDown.add(checkStart, self);  
        setSettings();
    }
    //pause = false;
}

function setSettings () {
    groupMenu = game.add.group();
    createBt('mute',315,66, 12);
    createBt('player2',315,158, 13);
    createBt('IA',315,209, 12);
    createBt('minD',651,66, 0);
    createBt('minU',665,66, 0);
    createBt('secD',685,66, 0);
    createBt('secU',699,66, 0);
    createBt('moins',730,66, 11);
    createBt('plus',744,66, 10);
    createBt('persoD',670,158, 0);
    createBt('persoU',684,158, 0);

    changeButton ('persoD', Math.floor(nbPersos/10));
    changeButton ('persoU', nbPersos%10);
}

function createBt (name, _x, _y, frame) {
    bt = game.add.sprite(_x+6,_y+6, 'chiffres');
    bt.name = name;
    bt.anchor.setTo(0.5,0.5);
    bt.animations.frame = frame;
    bt.scale.set(1.8,1.8);
    groupMenu.add(bt);
    groupMenu.setAll('inputEnabled', true);
    groupMenu.callAll('events.onInputDown.add', 'events.onInputDown', chekSet);
    afficheTempsSet();
}

function chekSet (e) {
    switch (e.name) {
        case 'mute':
            if (music.volume ==1) {
                music.volume = 0;
                e.animations.frame = 13;
            } else {
                music.volume = 1;
                e.animations.frame = 12;
            }
            break;
        case 'player2':
            if (e.animations.frame == 12) {
                e.animations.frame = 13;
                changeButton ('IA', 12);
                dumbIA = false;
            }
            break;
        case 'IA':
            if (e.animations.frame == 12) {
                e.animations.frame = 13;
                changeButton ('player2', 12);
                dumbIA = true;
            }
            break;
        case 'plus':
            temps += 10;
            if (temps>5999) temps = 5999;
            afficheTempsSet();
            break;
        case 'moins':
            temps -= 10;
            if (temps<30) temps = 30;
            afficheTempsSet();
            break;
        case 'persoD':
        case 'persoU':
            nbPersos++;
            if (nbPersos>maxPersos) nbPersos = 4;
            changeButton ('persoD', Math.floor(nbPersos/10));
            changeButton ('persoU', nbPersos%10);

    }
}

function changeButton (id, frame) {
    groupMenu.forEach(function(e){
        if (e.name == id) e.animations.frame = frame;
    })
}

function afficheTempsSet () {
    var minutes = Math.floor(temps/60);
    var secondes = temps %60;
    changeButton ('minD', Math.floor(minutes/10));
    changeButton ('minU', minutes%10);
    changeButton ('secD', Math.floor(secondes/10));
    changeButton ('secU', secondes%10);
}

function checkStart(e) {
    if (e.x>831 && e.x<913 && e.y>236 && e.y< 269) {
        groupMenu.callAll('events.onInputDown.remove', 'events.onInputDown', chekSet);
        var bt = groupMenu.getAt(0);
        while(bt != -1) {
            groupMenu.remove (bt);
            bt.kill();
            bt = groupMenu.getAt(0);
        }
        titre.kill();

        timerSprites.push (game.add.sprite (850,240,'chiffres'));
        timerSprites.push (game.add.sprite (872,240,'chiffres'));
        timerSprites.push (game.add.sprite (904,240,'chiffres'));
        timerSprites.push (game.add.sprite (926,240,'chiffres'));
        timerSprites.push (game.add.sprite (888,240,'chiffres'));
        timerSprites.forEach(function(e) {e.scale.set (3,3);});
        timerSprites[4].animations.frame = 24;
        timer.temps = temps;
        affTimer();

        win = game.add.sprite(50,235, 'win');
        win.scale.set (1.9,1.9);
        win.alpha = 0;

        addPersos();


        player1 = game.add.sprite(400,300, 'insp');
        // (nom, frames, fps, loop)
        player1.animations.add('nomove', [5,6,7,8], 3, true);
        player1.animations.add('marche', [0,1,2,3,4], 6, true);
        var animAccuse = player1.animations.add('accuse', [9], 0.5, false);
        animAccuse.onComplete.add(finAccuse, player1);
        player1.animations.play('nomove');
        player1.scale.set(3,3);
        player1.anchor.setTo(.5, .5);

        player2.orientLeft = true;
     
        game.physics.arcade.enable(player1);
        player1.body.setSize(16, 56,0,0);
        player1.body.collideWorldBounds = true;

        fleche = game.add.sprite(0,10, 'fleche');
        fleche.animations.add('move', [0,1], 3, true);
        fleche.animations.play('move');
        fleche.scale.set(0.5,0.5);
        fleche.alpha = 0;
        fleche.pivot.x = 20.5;
        fleche.pivot.y = 24.5;

        pause = false;
        timer.start();
    }
}

function lyingIA () {
    var nbLeft=0;
    tabPersos.forEach(function(e) {
        if (e != player2 && e.body.x<player2.body.x) nbLeft++;
    });

    if (nbLeft > (nbPersos-1)/2) return true;
    else return false;
}

function updateTimer () {
    timer.temps--;
    affTimer();
    if (timer.temps == 0) {
        focusInsp = null;
        checkEnd();
    }
}

function affTimer () {
    var minutes = Math.floor(timer.temps/60);
    var secondes = timer.temps%60;
    timerSprites[0].animations.frame = 14+Math.floor(minutes/10);
    timerSprites[1].animations.frame = 14+minutes%10;
    timerSprites[2].animations.frame = 14+Math.floor(secondes/10);
    timerSprites[3].animations.frame = 14+secondes%10;
}

function checkEnd () {
    game.estFini = true;
    timer.destroy();
    timer = null;
    fleche.rotation = 0;
    tabPersos.forEach(function(e) {
        
        stopPerso(e);
        if (e!= player2) e.alpha = 0.5;
        if (focusInsp!= null && focusInsp == player2) {
            player2.animations.play('perdu');
            win.animations.frame = 0;
        } else {
            player2.animations.play('gagne');
            win.animations.frame = 1;
        }
        win.alpha = 1;
        fleche.x = player2.body.x + 18;
        zIndexPersos.bringToTop(player2);
        });
}